#include <cstring>
#include "agenda.h"

agenda::agenda(int n){prim=ult=NULL; nrc=0; spatiu=n;}
agenda::agenda (agenda&A)
{
    spatiu=A.spatiu;
    nrc=A.nrc;
    prim=NULL;
    if (A.prim)
    {
      prim=new contact;
      *prim=*A.prim;
      ult=prim;
      for (contact*p=A.prim->urm;p!=NULL;p=p->urm)
      {
          contact*q=new contact;
          *q=*p;
          ult->urm=q;
          ult=q;
      }
      ult->urm=NULL;
    }
}

agenda:: ~agenda()
{
    contact*p;
    while (prim!=NULL)
    {
        p=prim;
        prim=p->urm;
        delete p;
    }
}


agenda agenda::operator+=(contact*c)
{
    if (nrc==0) {
			 prim = new contact;
			*prim=*c; nrc=1; ult=prim; prim->urm=NULL; }
    else
        if (nrc*sizeof(contact)>spatiu*1024*1024) cout <<"Spatiu insuficient";
           else
            {
              contact *p=new contact;
              *p=*c;
              p->urm=NULL;
              ult->urm=p;
              ult=p;
              nrc++;
             }
    return *this;
}

void agenda::adauga(contact*c)
{
	if (nrc==0) {
			prim = new contact;
			*(prim)=*c; nrc=1; prim->urm=NULL; ult=prim; }
    else
        if (nrc*sizeof(contact)>spatiu*1024*1024) cout <<"Spatiu insuficient";
           else
            {
              contact *p=new contact;
              *p=*c;
              p->urm=NULL;
              ult->urm=p;
              ult=p;
              /*A.ult->urm=new contact;
              *(A.ult->urm)=*c;
              A.ult=A.ult->urm;
              A.ult->urm=NULL;*/
              nrc++;
             }
}

istream& operator>> (istream&in, agenda&A)
{
    contact *p;
	int n;
    in>>n; in.get();
    for (int i=1;i<=n;i++)
    {
    	p=new contact;
        in.getline(p->nume,25);
        in.getline(p->tel,15);
        in >>p->cat; in.get();
        p->urm=NULL;
        //A.adauga(p);
        A+=p;
    }
    return in;
}

ostream& operator<<(ostream&out,agenda&A)
{
    contact *p=A.prim;
    for (int i=1;i<=A.nrc;i++)
    {
         out <<p->nume<<"; "<<p->tel<<"; "<<p->cat<<endl;
        p=p->urm;
    }
    return out;
}

contact* agenda::caut(char *s)
{
	contact *q;
	for (q=prim; q!=NULL;q=q->urm)
		if (strcmp(q->nume, s)==0 || strcmp(q->tel, s)==0) return q;
	return NULL;
}

void agenda::sterge(char *s)
{
	contact *p=caut(s), *q;;
	if (!p) cout<<s<<" nu este in agenda!\n";
	else{
		if (p==prim){
			if (p->urm) prim=p->urm,*prim=*(p->urm);
			else prim = ult = NULL;
		}
		else {
				for (q=prim; q->urm!=p; q=q->urm);
				q->urm=p->urm;
		}
		delete p;
		nrc--;
	}
}
